VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5400
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10815
   LinkTopic       =   "Form1"
   ScaleHeight     =   5400
   ScaleWidth      =   10815
   StartUpPosition =   2  'CenterScreen
   Begin MSComctlLib.ListView ListView1 
      Height          =   5175
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   10575
      _ExtentX        =   18653
      _ExtentY        =   9128
      LabelWrap       =   -1  'True
      HideSelection   =   -1  'True
      _Version        =   393217
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      NumItems        =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()

    Dim oListItem       As MSComctlLib.ListItem
    Dim dblDate         As Double
    
    ListView1.View = lvwReport
    ListView1.Sorted = True

    With ListView1.ColumnHeaders
        .Add Text:="Number"
        .Add Text:="Date1"
        .Add Text:="Date2"
        .Add Text:="Numbers"
        .Add Text:="Bad Sort"
        .Add                    '-- Dummy column. No text in case user pulls out to view.
        
        .Item(1).Width = 1000
        .Item(2).Width = 2100
        .Item(3).Width = 2100
        .Item(4).Width = 1600
        .Item(5).Width = 1000
        .Item(6).Width = 0      '-- Dummy column.
    End With

    '-- Put some data in the listview.
    With ListView1.ListItems
        Do While .Count < 10

            Set oListItem = .Add(, , "Item: " & .Count + 1)
            oListItem.Tag = Format(.Count + 1, "00000")

            dblDate = Rnd * 10
            oListItem.ListSubItems.Add , , CDate(dblDate)
            oListItem.ListSubItems(1).Tag = Format$(dblDate, "yyyymmddHHMMSS")

            dblDate = Rnd * 10
            oListItem.ListSubItems.Add , , CDate(dblDate)
            oListItem.ListSubItems(2).Tag = Format$(dblDate, "yyyymmddHHMMSS")

            dblDate = Rnd * 10
            oListItem.ListSubItems.Add , , dblDate
            oListItem.ListSubItems(3).Tag = Format$(dblDate, "000000000000.0000000000")
            
            '-- No tag property - will get sorted incorrectly.
            dblDate = Rnd * 10
            oListItem.ListSubItems.Add , , "Item: " & .Count * 5
            
            '-- Dummy ListSubItems column.
            oListItem.ListSubItems.Add

        Loop
        
    End With
End Sub

Private Sub ListView1_ColumnClick(ByVal ColumnHeader As MSComctlLib.ColumnHeader)
    Call SortListView(ListView1, ColumnHeader)
End Sub


Public Sub SortListView(ByRef oListView As MSComctlLib.ListView, _
                        ByRef oColumnHeader As MSComctlLib.ColumnHeader)
'-- Sorts all list items correctly according to data type.
'-- Requirements:
'--     Any items without tag data will be sorted alphabetically.
'--     When creating the list, add a dummy column to the end, width = 0.
'--     Must be the last column in the list.
'--     Create the dummy column subitems as you fill the loop.
'--     Set .Sorted property = True.

    Dim oListItem           As MSComctlLib.ListItem
    Dim i                   As Integer
    Dim iTempColIndex       As Integer
    Dim bNoTagInColumn      As Boolean
    
    With oListView
    
        '-- If 0 or 1 items or -1(uninitialized), then don't try to sort.
        If .ListItems.Count < 2 Then GoTo Exit_Point
        
        iTempColIndex = .ColumnHeaders.Count - 1


        '-- Add the tag data from the clicked-on column to the dummy column.
        If oColumnHeader.Index = 1 Then
            '-- First column gets special treatment.
            For i = 1 To .ListItems.Count
                Set oListItem = .ListItems(i)
                oListItem.ListSubItems(iTempColIndex) = oListItem.Tag
            Next
            If Len(Trim(oListItem.Tag)) = 0 Then bNoTagInColumn = True
        Else
            '-- Subcolumns.
            For i = 1 To .ListItems.Count
                Set oListItem = .ListItems(i)
                oListItem.ListSubItems(iTempColIndex) = oListItem.ListSubItems(oColumnHeader.Index - 1).Tag
            Next
            If Len(Trim(oListItem.ListSubItems(iTempColIndex))) = 0 Then bNoTagInColumn = True
        End If
        
        
        If bNoTagInColumn Then
            '-- If the tag is blank, sort by default - alphabetically.
            .SortKey = oColumnHeader.Index - 1
        Else
            '-- Otherwise sort by the dummy column.
            .SortKey = iTempColIndex
        End If
        
        '-- Sort.
        If .SortOrder = lvwAscending Then
            .SortOrder = lvwDescending
        Else
            .SortOrder = lvwAscending
        End If
        
        
        '-- Remove the data so no peeking.
        For i = 1 To .ListItems.Count
            Set oListItem = .ListItems(i)
            oListItem.ListSubItems(iTempColIndex) = ""
        Next

    End With
    
Exit_Point:
    Set oListItem = Nothing
End Sub



